program winevent_demo;

{
    WinSync Sample Semaphoren
}

{$mode objfpc}{$H+}

uses
  cthreads,
  Classes, SysUtils, uwinevent;


type

  { TWaitThread }

  TWaitThread = Class(TThread)
  private
    fWorkSem, fTerminateSem : THandle;
    FEvents: PWOHandleArray;
  protected
    procedure Execute; override;
  public
    constructor Create(aWorkSem, aTerminateSem : THandle);
  end;

{ TWaitThread }

procedure TWaitThread.Execute;
Var
  aCnt : Integer;
begin
  aCnt := 0;
  GetMem(FEvents,2*Sizeof(THandle));
  FEvents^[0] := fWorkSem;
  FEvents^[1] := fTerminateSem;


  while true do
  begin
    case WaitForMultipleObjects(2, FEvents, false, INFINITE) of
      WAIT_OBJECT_0:     //aWorkSem released
        begin
          Inc(aCnt);     //Thread do Samething
        end;
      WAIT_OBJECT_0 + 1: //aTerminateSem released
        begin
          Break
        end;
    end;
  end;
  FreeMem(FEvents,2*Sizeof(THandle));

  Terminate;
  WriteLn('Thread End with workcount ', aCnt);
end;

constructor TWaitThread.Create(aWorkSem, aTerminateSem: THandle);
begin
  fWorkSem := aWorkSem;
  fTerminateSem := aTerminateSem;
  inherited Create(false)
end;

var
  aThread : TWaitThread;
  aSem, aSem2 : THandle;
  i : Integer;
begin
  i := 0;
  aSem := CreateSemaphore(nil, 0, $FFFF, nil);
  aSem2 := CreateSemaphore(nil, 0, $FFFF, nil);
  try
    aThread := TWaitThread.Create(aSem, aSem2);
    try
      repeat
        Sleep(100);
        inc(i);

        if i = 10 then                      //After 1 sec say thread work
          ReleaseSemaphore(aSem, 2, nil);

        if i = 15 then
          ReleaseSemaphore(aSem, 1, nil);   //After 1,5 msec say thread work two times

        if i = 20 then
          ReleaseSemaphore(aSem2, 1, nil);  //After 2sec say thread stop work
      until aThread.Terminated;             //thread must end with an workcount from 3
    finally
      aThread.WaitFor;
      aThread.Free;
    end;
  finally
    CloseHandle(aSem);
    CloseHandle(aSem2);
  end;
end.

