program winevent_evnt;

{
    WinSync Sample Events
}

{$mode objfpc}{$H+}

uses
  cthreads,
  Classes, SysUtils, uwinevent;


type

  { TWaitThread }

  TWaitThread = Class(TThread)
  private
    fWorkEvent, fTerminateSem : THandle;
    FEvents: PWOHandleArray;
  protected
    procedure Execute; override;
  public
    constructor Create(aWorkEvent, aTerminateSem : THandle);
  end;

{ TWaitThread }

procedure TWaitThread.Execute;
Var
  aEventOpen : Boolean;
begin
  aEventOpen := false;
  GetMem(FEvents,2*Sizeof(THandle));
  FEvents^[0] := fWorkEvent;
  FEvents^[1] := fTerminateSem;


  while true do
  begin
    case WaitForMultipleObjects(2, FEvents, false, 10) of
      WAIT_OBJECT_0:     //aWorkSem released
        begin
          if not aEventOpen then
          begin
            aEventOpen := true;
            WriteLn('Event is set');
          end;
        end;
      WAIT_OBJECT_0 + 1: //aTerminateSem released
        begin
          Break
        end;
      WAIT_TIMEOUT :
        begin
          if aEventOpen then
          begin
            aEventOpen := false;
            WriteLn('Event is reset');
          end;
        end;
    end;
  end;
  FreeMem(FEvents,2*Sizeof(THandle));

  Terminate;
end;

constructor TWaitThread.Create(aWorkEvent, aTerminateSem: THandle);
begin
  fWorkEvent := aWorkEvent;
  fTerminateSem := aTerminateSem;
  inherited Create(false)
end;

var
  aThread : TWaitThread;
  aEvent, aSem2 : THandle;
  i : Integer;
begin
  i := 0;
  aEvent := CreateEvent(nil, true, false, nil);
  aSem2 := CreateSemaphore(nil, 0, $FFFF, nil);
  try
    aThread := TWaitThread.Create(aEvent, aSem2);
    try
      repeat
        Sleep(100);
        inc(i);

        if i = 10 then                      //After 1 sec setEvent
          SetEvent(aEvent);

        if i = 15 then
          ResetEvent(aEvent);               //After 200 msec resetEvent

        if i = 20 then
          ReleaseSemaphore(aSem2, 1, nil);  //After 2sec say thread stop work
      until aThread.Terminated;
    finally
      aThread.WaitFor;
      aThread.Free;
    end;
  finally
    CloseHandle(aEvent);
    CloseHandle(aSem2);
  end;
end.

