program winevent_waittimer;

{$mode objfpc}{$H+}

uses
  cthreads,
  Classes, SysUtils, uwinevent, uconsoletimer;

type

  { TTimedThread }

  TTimedThread = Class(TThread)
  private
    FEvents : PWOHandleArray;
    fCheckTimer : THandle;
    fKillEvent : THandle;
  protected
    procedure Execute; override;
  public
    constructor Create;
    destructor Destroy; override;
  end;

{ TTimedThread }

constructor TTimedThread.Create;
Var
  aLi : TLargeInteger;
begin
  fKillEvent := CreateEvent(nil, false, false, nil);
  fCheckTimer := CreateWaitableTimer(nil, false, nil);
  SetWaitableTimer(fCheckTimer, aLi, 2000, nil, nil, false);
  
  GetMem(FEvents,2*Sizeof(THandle));
  FEvents^[0] := fCheckTimer;
  FEvents^[1] := fKillEvent;
  
  inherited Create(false);
end;

destructor TTimedThread.Destroy;
begin
  Freemem(FEvents, 2*Sizeof(THandle));
  CloseHandle(fKillEvent);
  CloseHandle(fCheckTimer);
  inherited Destroy;
end;


procedure TTimedThread.Execute;
var
  aCnt : Integer;
begin
  aCnt := 0;
  while not Terminated do
  begin
    WriteLn('Wait for events');
    case WaitForMultipleObjects(2, FEvents, false, INFINITE) of
      WAIT_OBJECT_0 :
        begin
          Inc(aCnt);
          WriteLn('Timer Called ', aCnt);
          if aCnt = 5 then
            SetEvent(fKillEvent);
        end;
      WAIT_OBJECT_0 + 1 :
        begin
          Terminate;
          Break;
        end;
    end;
  end;
end;


var
  aTimedThread : TTimedThread;
begin
  aTimedThread := TTimedThread.Create;
  try
    repeat
      Sleep(100); //Wait thread finished
    until aTimedThread.Terminated;
  finally
    aTimedThread.Free;
  end;
end.



